# -*- coding: utf-8; -*-
################################################################################
#
#  WuttaFarm --Web app to integrate with and extend farmOS
#  Copyright © 2026 Lance Edgar
#
#  This file is part of WuttaFarm.
#
#  WuttaFarm is free software: you can redistribute it and/or modify it under
#  the terms of the GNU General Public License as published by the Free Software
#  Foundation, either version 3 of the License, or (at your option) any later
#  version.
#
#  WuttaFarm is distributed in the hope that it will be useful, but WITHOUT ANY
#  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
#  A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along with
#  WuttaFarm.  If not, see <http://www.gnu.org/licenses/>.
#
################################################################################
"""
Custom form widgets for WuttaFarm
"""

import json

import colander


class AnimalTypeType(colander.SchemaType):

    def __init__(self, request, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.request = request

    def serialize(self, node, appstruct):
        if appstruct is colander.null:
            return colander.null

        return json.dumps(appstruct)

    def widget_maker(self, **kwargs):  # pylint: disable=empty-docstring
        """ """
        from wuttafarm.web.forms.widgets import AnimalTypeWidget

        return AnimalTypeWidget(self.request, **kwargs)


class StructureType(colander.SchemaType):

    def __init__(self, request, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.request = request

    def serialize(self, node, appstruct):
        if appstruct is colander.null:
            return colander.null

        return json.dumps(appstruct)

    def widget_maker(self, **kwargs):  # pylint: disable=empty-docstring
        """ """
        from wuttafarm.web.forms.widgets import StructureWidget

        return StructureWidget(self.request, **kwargs)


class UsersType(colander.SchemaType):

    def __init__(self, request, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.request = request

    def serialize(self, node, appstruct):
        if appstruct is colander.null:
            return colander.null

        return json.dumps(appstruct)

    def widget_maker(self, **kwargs):  # pylint: disable=empty-docstring
        """ """
        from wuttafarm.web.forms.widgets import UsersWidget

        return UsersWidget(self.request, **kwargs)
